<template>
  <div class="taskListBox">
    <div class="header">
      <div class="title">
        <img src="../../assets/images/mount_head.png" />
        <div class="font">任务库</div>
      </div>
    </div>
    <el-form class="task-main" label-width="60px">
      <el-form-item label="任务库">
        <el-tooltip :content="clew" placement="top">
          <el-cascader
            filterable
            popper-class="mmc"
            size="mini"
            class
            style="width: 100%"
            v-model="selectedTaskId"
            :options="taskListAll"
            clearable
            :show-all-levels="false"
            placeholder="请选择任务"
            :props="{
              children: 'children',
              label: 'name',
              value: 'id',
            }"
            @change="onChangeTask"
          >
            <template slot-scope="{ data }">
              <el-tooltip class="item" effect="dark" :content="data.name" placement="top-start">
                <span>{{ data.name }}</span>
              </el-tooltip>
            </template>
          </el-cascader>
        </el-tooltip>
      </el-form-item>
      <el-form-item label="航线">
        <el-tooltip content="航线名称" placement="top">
          <el-input
            v-if="isSelectTask || selectedAirway.id !== -1"
            disabled
            v-model="selectedAirway.name"
            placeholder="请选择航线"
            class
            style="width: 100%"
            size="mini"
          ></el-input>
          <el-button v-else class="select-airway__btn" @click="showFlywayDialog = true">选择航线</el-button>
        </el-tooltip>
      </el-form-item>
      <div class="btn" @click="onStartTask">一键任务</div>
      <!-- <div class>
        <span class="btn__add-line">
          <span class="f8"></span> 创建航线
        </span>
      </div>-->
    </el-form>
    <LineList v-if="showFlywayDialog" @close="showFlywayDialog = false;" @change="onChangeLine"></LineList>
  </div>
</template>
<script>
import LineList from "./components/lineList";
import methods from "./methods";
import { mapState } from "vuex";
import Vue from "vue";

export default {
  name: "taskList",
  components: { LineList },
  props: {},
  inject: ["rootNode", "bus"],
  data() {
    return {
      // 选择的任务id
      selectedTaskId: [],
      // 航线数据
      flightList: [],
      // 航线id
      flightId: "",
      flightIdv2: "",
      // 选择的航线
      selectedAirway: {
        name: "",
        id: -1,
      },
      // 航线选择窗口
      showFlywayDialog: false,
      clew: "任务库", // 选中任务提示语
    };
  },
  computed: {
    ...mapState("MMCFlightControlCenter", ["taskList"]),
    ...mapState("MMCFlightControlCenter/uavApplications", ["uav"]),
    taskListAll() {
      return [{ name: "选择航线自动生成任务", id: -1 }, ...this.taskList];
    },
    /**
     * 是否选择任务
     */
    isSelectTask() {
      return this.selectedTaskId[0] !== -1;
    },
    /**
     * 选择的任务数据
     */
    selectedTask() {
      let find = this.taskList.find((item) => {
        return item.id === this.selectedTaskId[this.selectedTaskId.length - 1];
      });
      return find;
    },
  },
  watch: {},
  async created() {
    this.bus.$on("startTask", this.onStartTask);
  },
  methods: {
    /**
     * 更改航线事件
     */
    onChangeLine(data) {
      this.selectedAirway = data;
    },
    /**
     * 一键任务事件
     */
    async onStartTask() {
      if (this.selectedAirway.id === -1) {
        this.$message.warning("请选择航线");
        return;
      }
      try {
        await this.$confirm("请确认是否进行一键任务操作?", "安全确认", {
          cancelButtonText: "取消",
          confirmButtonText: "确定",
          customClass: "uav_controlPane",
          showClose: false,
        });
        if (this.selectedAirway.id === -1) {
          this.$store.commit(
            "MMCFlightControlCenter/uavApplications/setState",
            {
              key: "airlineData",
              value: null,
            }
          );
        } else {
          this.$store.commit(
            "MMCFlightControlCenter/uavApplications/setState",
            {
              key: "airlineData",
              value: this.selectedAirway,
            }
          );
        }
        this.$store.dispatch("MMCFlightControlCenter/uavApplications/takeOff");
        this.rootNode.$emit(
          "startTask",
          this.uav,
          this.selectedTask,
          this.selectedAirway
        );
      } catch (e) {}
    },
    /**
     * 更改任务事件
     */
    onChangeTask() {
      this.selectedAirway = this.selectedTask?.airway || {
        name: "",
        id: -1,
      };
    },
  },
};
</script>
<style lang="scss" scoped>
.taskListBox {
  min-height: 254px;
  width: 380px;
  background: rgba(9, 32, 87, 0.7);
  border-radius: 10px;
  transition: 0.3s;

  .header {
    display: flex;
    justify-content: space-between;
    height: 32px;
    background: linear-gradient(
      180deg,
      #9198ff 0%,
      rgba(45, 81, 153, 0.45) 40%,
      #05091a 100%
    );
    box-shadow: inset 0px 0px 10px 2px #3f9dff;
    border-radius: 10px 10px 0px 0px;
    border: 1px solid #427dff;
    .title {
      display: flex;
      align-items: center;
      margin-left: 10px;
      .font {
        font-size: 20px;
        font-family: YouSheBiaoTiHei;
        color: #14faff;
        line-height: 26px;
        text-shadow: 0px 1px 1px rgba(2, 32, 56, 0.2);
        background: linear-gradient(
          135deg,
          #e3aa77 0%,
          #f5cda9 38%,
          #f9ecd3 58%,
          #fcdbb1 79%,
          #edb07a 100%
        );
        -webkit-background-clip: text;
        -webkit-text-fill-color: transparent;
      }
    }
    .active {
      background-image: linear-gradient(
        180deg,
        #9198ff 0%,
        rgba(45, 81, 153, 0.22) 40%,
        #05091a 100%
      );
      border: 1px solid #70daf9;
      box-shadow: inset 0 0 10px 2px #3f9dff;
      font-family: MicrosoftYaHei-Bold;
      font-size: 14px;
      color: #70daf9;
      letter-spacing: 0;
      font-weight: 700;
    }

    .default {
      background-image: linear-gradient(
        180deg,
        #9198ff 0%,
        rgba(45, 81, 153, 0.22) 40%,
        #05091a 100%
      );
      border: 1px solid #70daf9;
      font-family: MicrosoftYaHei-Bold;
      font-size: 14px;
      color: rgba(112, 218, 249, 0.5);
      letter-spacing: 0;
      font-weight: 700;
    }
  }
  .task-main::v-deep {
    padding: 38px 30px;
    position: relative;

    .el-form-item__label {
      color: #fff;
    }

    .btn__add-line {
      position: absolute;
      bottom: 20px;
      right: 20px;
      font-size: 10px;
      color: #43deff;
      cursor: pointer;
    }
  }

  .btn {
    width: 122px;
    height: 32px;
    text-align: center;
    line-height: 32px;
    margin: 0 auto;
    margin-bottom: 10px;
    color: #fff;
    background: url("../../assets/images/btn_lan.png") no-repeat;
    background-size: 100% 100%;
    cursor: pointer;
  }
}
.select-airway__btn {
  width: 100%;
  height: 30px;
  padding: 0;
}
</style>
